#
# spec file for package horde3
#
# Copyright (c) 2012 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define _phpdir php5
%define peardir %(pear config-get php_dir 2> /dev/null)
%define _hordedir /srv/www/htdocs/horde

Name:           horde3
Summary:        Core Pieces for Running H3 Web Applications
License:        GPL-2.0+
Group:          Productivity/Networking/Web/Utilities
Version:        3.3.13
Release:        0.3.2
Url:            http://www.horde.org/
Source0:        horde-%{version}.tar.gz
Source1:        COPYING
############################
Patch0:         horde-3.1.2-log.patch
Patch1:         horde-fatal-on-admin-3.3.11.patch
Patch2:         horde-finer-grained-admin-privileges.patch
Patch3:         horde-3.2-rc1-usr_local.patch
Patch4:         horde-3.3.9-php5_exec.patch
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  apache2-devel
# This check is still needed for SLE_10
%if 0%{?suse_version} > 1020
BuildRequires:  fdupes
%endif
BuildRequires:  pcre-devel
BuildRequires:  php5-pear
Requires:       mod_php_any
Requires:       php-gettext
Requires:       php-mcrypt
Requires:       php-imap
Requires:       php-pear
Requires:       php5-pear-Log
Requires:       php-session
Requires:       php-dom
Requires:       php5 
Requires:       php5-pear-Auth_SASL
Requires:       php5-pear-Date
Requires:       php5-pear-File
Requires:       php5-pear-Mail
Requires:       php5-pear-Mail_Mime
Requires:       php5-pear-DB
Requires:       php5-pear-MDB2
Requires:       php5-pear-Net_IMAP
Requires:       php5-pear-services_weather
Requires:       php5-pear-SOAP
Requires:       php5-pear-Text_CAPTCHA
Requires:       php5-pear-Text_Figlet
# this is atm provided by horde itself
#Requires:	php5-pear-text_diff
Requires:       php5-pear-HTTP_Request
Requires:       php5-pear-Services_Weather
Requires:       php5-pear-XML_SVG

%description
These are the core pieces of the Horde suite of Web applications. This
package is needed to run any of the other programs, such as IMP.

%prep
%setup %setup -qn horde-%{version}
%patch0
%patch1
%patch2
%patch3
if test -e /usr/bin/php5; then
%patch4 -p1
fi
# Remove the .orig files that are created by the above patch' commands
find -name "*.orig" -exec rm {} \;

%build
: if the following command fails, then apache dependencies are not met
/usr/sbin/apxs2 -q datadir >/dev/null
cd config
for i in *.dist; do
  %__mv $i ${i%.dist}
done

%install
%__mkdir_p %{buildroot}%{_hordedir}
%__cp -r ./* %{buildroot}%{_hordedir}
%__cp  %{SOURCE1} %{buildroot}%{_hordedir}
%__cp  %{SOURCE1} %{buildroot}%{_hordedir}/services/editor/fckeditor/license.txt
%__cp  %{SOURCE1} %{buildroot}%{_hordedir}/services/editor/tinymce/license.txt
%__rm -rf %{buildroot}%{_hordedir}/{docs,README,LICENSE}
%if 0%{?sles_version} != 10 
 %fdupes %buildroot%{_hordedir}
%endif
%find_lang horde
%__install -d %{buildroot}/var/log/horde

# The following files are removed, because they are now provided
# by the packages: horde-auth, horde-group, horde-prefs, kolab-filter,
# kolab-format, kolab-freebusy, kolab-server and kolab-storage.
#
# The following files are provided by horde, it seems that should
# not be the case.
# Horde/Kolab/Storage/Session.php
# Horde/Prefs/kolab_imap.php
# Horde/Share/kolab.php
%__rm -rf %{buildroot}%{_hordedir}/lib/Horde/Kolab

# prevent rpmlint warning / errors
%if 0%{?suse_version} > 1020
%fdupes %{buildroot}%{_hordedir}/admin
%fdupes %{buildroot}%{_hordedir}/js
%fdupes %{buildroot}%{_hordedir}/lib
%fdupes %{buildroot}%{_hordedir}/po
%fdupes %{buildroot}%{_hordedir}/themes
%fdupes %{buildroot}%{_hordedir}/scripts
%fdupes %{buildroot}%{_hordedir}/templates
%fdupes %{buildroot}%{_hordedir}/docs
%fdupes %{buildroot}%{_hordedir}/services
%fdupes %{buildroot}%{_hordedir}/rpc
%fdupes %{buildroot}%{_hordedir}/util
%endif

%__install -d -m 755 %{buildroot}%{peardir}/Horde
%find_lang horde

%clean
%__rm -rf %{buildroot}

%files -f horde.lang
%defattr(0640, root, root,0750)
%doc README docs
%doc %{_hordedir}/COPYING
%dir %{_hordedir}
%dir %{_hordedir}/locale
%dir %{_hordedir}/locale/*/LC_MESSAGES/
%dir %{_hordedir}/locale/*/
%{_hordedir}/locale/.htaccess
%{_hordedir}/locale/*/help.xml
%{_hordedir}/admin
%{_hordedir}/js
%{_hordedir}/lib
%{_hordedir}/po
%attr(0775, wwwrun, root ) %{_hordedir}/po/translation.php
%dir %{_hordedir}/locale
%dir %{_hordedir}/locale/en_US
%dir %{_hordedir}/scripts/
%dir %{_hordedir}/scripts/upgrades/
%attr(0750, root, www) %{_hordedir}/scripts/*.php
%{_hordedir}/scripts/sql
%{_hordedir}/scripts/upgrades/*.sql
%attr(0750, root, www) %{_hordedir}/scripts/upgrades/*.php
%{_hordedir}/scripts/ldap
#
%{_hordedir}/scripts/.htaccess   
%{_hordedir}/scripts/SCRIPTS   
%{_hordedir}/scripts/horde.logrotate   
%attr(0775, wwwrun, root ) %{_hordedir}/scripts/set_perms.sh  
%attr(0775, wwwrun, root ) %{_hordedir}/scripts/temp-cleanup.cron
%{_hordedir}/scripts/share-stress-test-conf.php.dist
%{_hordedir}/scripts/share-stress-test-sql.xml   
%{_hordedir}/scripts/share-stress-test-sqlng.xml
%{_hordedir}/services
%{_hordedir}/templates
%{_hordedir}/themes
%{_hordedir}/util
%{_hordedir}/rpc
%{_hordedir}/*.php
%attr(0750, wwwrun, www) %dir %{_hordedir}/config
%attr(0640, root, www)   %config(noreplace) %{_hordedir}/config/.htaccess
%attr(0640, wwwrun, www) %config(noreplace) %{_hordedir}/config/*.php
%attr(0640, wwwrun, www) %config(noreplace) %{_hordedir}/config/*.xml
%attr(0750, wwwrun, www) %dir %{_hordedir}/config/registry.d
%attr(0640, wwwrun, www) %{_hordedir}/config/registry.d/README
%attr(0750, wwwrun, www) %dir /var/log/horde

%post
if [[ "$1" == 1 ]]; then
  # Horde is not yet installed on the system
  if ! grep -q "^include_path.*/srv/www/htdocs/horde/lib" /etc/php5/cli/php.ini; then
    # The directory /srv/www/htdocs/horde/lib, must be placed before
    # /usr/share/php5/PEAR otherwise applications will fail
    eval $(grep -w ^include_path /etc/php5/cli/php.ini | tr -d " ")
    for D in $(tr ":" " " <<< $include_path); do
      if [[ $D == "/usr/share/php5/PEAR" ]]; then
        INCLUDE_PATH="$INCLUDE_PATH:/srv/www/htdocs/horde/lib"
      fi
      INCLUDE_PATH="$INCLUDE_PATH:$D"
    done

    # Replace the include_path and remove the ":" at the beginning of the line
    cp /etc/php5/cli/php.ini /etc/php5/cli/php.ini-rpm-%{version}-%{release}
    sed -i "s,^include_path = .*,include_path = \"${INCLUDE_PATH##:}\"," /etc/php5/cli/php.ini
  fi
fi

%postun
if [[ "$1" == 0 ]]; then
  # Horde is removed from the system
  if grep -qw /srv/www/htdocs/horde/lib /etc/php5/cli/php.ini; then
    cp /etc/php5/cli/php.ini /etc/php5/cli/php.ini-rpm-%{version}-%{release}-remove
    sed -i 's,/srv/www/htdocs/horde/lib:*,,' /etc/php5/cli/php.ini
  fi
fi

%changelog
* Sat Feb 11 2012 lang@b1-systems.de
- bnc#742804 ( CVE-2012-0909)
- version 3.3.13
- Fixed a XSS vulnerability (CVE-2012-0909).
- Added support for resetting passwords in LDAP.
- Fixed compatibility with Firefox 10.
- Warning: Official support EOL for all things Horde3 ends April 2012
* Fri Oct 21 2011 chris@computersalat.de
- fix build
  * no space before "%%patch" macro
- spec cleanup
* Mon Oct  3 2011 coolo@suse.com
- only patch exec path if php5 really exists (e.g. not 12.1)
* Sat Aug 13 2011 lang@b1-systems.de
- version 3.3.12
- [jan] Convert charset of group names in SQL driver (Bug #9611).
- [jan] Fix deleting of SyncML anchors if PHP short_open_tag is off (Bug #9349).
- [jan] Add an experimental new Share SQL driver with better performance.
- [jan] Fix integer overflow in ASN.1 parser for S/MIME messages.
- [jan] Fix splitread database usage in VFS (Bug #9467).
- [jan] Fix invalidating permission cache in SQL driver (Bug #9392).
* Tue May 24 2011 lang@b1-systems.de
- small fixes to make it run in current factory
* Fri Jan 28 2011 lang@b1-systems.de
- changed last dependencies to new php-macros packaged pear classes
* Tue Jan 25 2011 lang@b1-systems.de
- updated some dependencies to newer package names
* Thu Dec 16 2010 lang@b1-systems.de
- updated patch because it contained CVS info
* Thu Dec 16 2010 lang@b1-systems.de
- updated to 3.3.11
- Added the fatal on admin and finer grained admin privileges patch
* Sat Oct 30 2010 lang@b1-systems.de
- made specfile more like those of the other horde packages
- added findlang to catch the .mo files
- removed kolab-related stuff which needs to go into a separate rpm
- added the finer grained administration patch
* Mon Oct 25 2010 lang@b1-systems.de
- updated to 3.3.10 which runs on PHP 5.3
* Sat Oct 16 2010 lang@b1-systems.de
- adding restriction to php versions prior to 5.3 because there are some known issues which need to be fixed first
- moving old changelog to changes file
* Tue Oct 12 2010 lang@b1-systems.de
- expanded horde-3.3.9-php5_exec.patch to new files
- updated to version 3.3.9
- de-fuzz patch to fix build on 11.3+
* Tue Nov  3 2009 rbos@opensuse.org
- Updated to version 3.3.5
- Updated patch horde-3.1.3-php5_exec.patch to horde-3.3.5-php5_exec.patch
  to match the current horde version
* Sun Mar  1 2009 rbos@opensuse.org
- Removed the link from /srv/www/htdocs/horde/lib to /usr/share/php5
  And added post and postun scripts to add or to remove the directory
  /srv/www/htdocs/horde/lib to include_path in the php.ini file to compensate
  for the removed links
* Sat Feb 21 2009 rbos@opensuse.org
- updated to version 3.3.3
* Tue Dec 23 2008 rbos@opensuse.org
- Required rpm php-pear-mail_mime changed to php5-pear-mail_mime
* Sun Dec 21 2008 rbos@opensuse.org
- Made this package the owner of the directory /usr/share/php5/PEAR/Horde, to
  prevent rpmlint errors in other package builds
* Sun Dec  7 2008 rbos@opensuse.org
- Ensure that the directory %%%%{peardir}/Horde is owned by this package
* Sat Dec  6 2008 rbos@opensuse.org
- Version 3.3
